<p align="center">
  <a href="https://velocityx.dev/" target="_blank">
    <h1>VelocityX</h1>
  </a>
</p>

<p align="center">
  <a href="https://velocityx.dev/" target="_blank">
    <img src="https://i.imgur.com/CXEiorH.png"  width="800" alt="VelocityX">
  </a>
</p>

[**VelocityX**](https://velocityx.dev/) is a 100% free Flutter open-source minimalist UI Framework built with <a href="https://flutter.dev/" target="_blank">Flutter SDK</a> to make Flutter development easier and more joyful than ever.

## Inspired from Tailwindcss and SwiftUI.

```dart
"Web".text.white.xl4.bold.center.makeCentered().box.roundedLg.red500.shadow2xl.make().whHalf(context).centered();
```

---

## Why use VelocityX?

<img src="https://i.imgur.com/UNf4fE6.png" width="300">
<img src="https://i.imgur.com/UAzM6iT.png" width="290">
<img src="https://i.imgur.com/rE46nEL.png" width="245">

### Show some :heart: and star the repo.

[![GitHub followers](https://img.shields.io/github/followers/iampawan.svg?style=social&label=Follow)](https://github.com/iampawan/)
[![Twitter Follow](https://img.shields.io/twitter/follow/imthepk.svg?style=social)](https://twitter.com/imthepk)

[![Open Source Love](https://badges.frapsoft.com/os/v1/open-source.svg?v=102)](https://opensource.org/licenses/Apache-2.0)

# Quick start

Read the [Getting started page of VelocityX](https://velocityx.dev/docs/install)

## VelocityX Video Tutorials

[Watch here](https://www.youtube.com/playlist?list=PLR2qQy0Zxs_UHLXSYbK50jEapx0ORmLYv)

---

<a href="https://www.buymeacoffee.com/mtechviral"><img src="https://img.buymeacoffee.com/button-api/?text=Buy me a coffee&emoji=&slug=mtechviral&button_colour=5F7FFF&font_colour=ffffff&font_family=Cookie&outline_colour=000000&coffee_colour=FFDD00"></a>

---

## Some popular Vx widgets

| [VxTimeline]()                                                                  | [VxAnimation]()                                                                         | [VxSwiper]()                                                                          | [VxResponsive]()                                                                      |
| ------------------------------------------------------------------------------- | --------------------------------------------------------------------------------------- | ------------------------------------------------------------------------------------- | ------------------------------------------------------------------------------------- |
| <img src="https://imagizer.imageshack.com/img922/3315/lYf8pd.png"  width="400"> | <img src="https://imagizer.imageshack.com/img924/6697/M7az7V.png" width="400" />        | <img src="https://imagizer.imageshack.com/img923/4109/Mmsi87.png" width="400">        | <img src="https://imagizer.imageshack.com/img924/1754/lry31m.png" width="400">        |
| Demo 1                                                                          | Demo 2                                                                                  | Demo 3                                                                                | Demo 4                                                                                |
| <img src="https://i.imgur.com/xtUOjiV.gif"  width="400">                        | <img src="https://imagizer.imageshack.com/v2/1024x768q90/922/YgXVGd.png" width="400" /> | <img src="https://imagizer.imageshack.com/v2/1024x768q90/924/u5VAhU.png" width="400"> | <img src="https://imagizer.imageshack.com/v2/1024x768q90/922/kNs9eC.png" width="400"> |

## Some quick UIs made using VelocityX

| Demo                                                      | Demo2                                                     |
| --------------------------------------------------------- | --------------------------------------------------------- |
| <img src="https://i.imgur.com/Uk28KcB.png" width="300"/>  | <img src="https://i.imgur.com/V0mr3S9.png" width="300"/>  |
| <img src="https://i.imgur.com/50tJKqU.png"  width="300"/> | <img src="https://i.imgur.com/vNPjDMs.png"  width="300"/> |
| <img src="https://i.imgur.com/cWlCo6P.png" width="300"/>  | <img src= "https://i.imgur.com/Xpdx9UP.png" width="300">  |

## Contributing

VelocityX is **100% free** and **open source**. We encourage and support an active, healthy community that accepts contributions from the public &ndash; including you. There are a couple of ways in which you can contribute to the growing community of `VelocityX`.

- Pick up any issue marked with ["good first issue"](https://github.com/iampawan/velocityx/issues?q=is%3Aopen+is%3Aissue+label%3A%22good+first+issue%22)
- Fix a bug
- Write and improve some **documentation**. Documentation is very critical to us. We would appreciate help in adding multiple languages to our docs.
- If you are a developer, feel free to check out the source and submit pull requests.
- Dig into [**CONTRIBUTING.MD**](CONTRIBUTING.md), which covers submitting bugs, requesting new features, preparing your code for a pull request, etc.
- Please don't forget to **like**, **follow**, and **star our repo**!

# Documentation

[**Installation Guide**](https://velocityx.dev/docs/install)

### :heart: Found this project useful?

If you found this project useful, then please consider giving it a :star: on Github and sharing it with your friends via social media.

---

### YouTube Channel

[MTechViral](https://www.youtube.com/mtechviral)

### Facebook Group

[Let's Flutter With Dart](https://www.facebook.com/groups/425920117856409/)

### Collection of flutter apps with tutorial

[Flutter Example Apps](https://github.com/iampawan/FlutterExampleApps)

---

## Project Created & Maintained By

### Pawan Kumar

Google Developer Expert for Flutter. Passionate #Flutter, #Android Developer. #Entrepreneur #YouTuber

<a href="https://play.google.com/store/apps/dev?id=7703305844118303242&hl=en"><img src="https://github.com/aritraroy/social-icons/blob/master/play-store-icon.png?raw=true" width="60"></a> <a href="https://medium.com/@imthepk"><img src="https://github.com/aritraroy/social-icons/blob/master/medium-icon.png?raw=true" width="60"></a>
<a href="https://twitter.com/imthepk"><img src="https://github.com/aritraroy/social-icons/blob/master/twitter-icon.png?raw=true" width="60"></a>
<a href="https://linkedin.com/in/imthepk"><img src="https://github.com/aritraroy/social-icons/blob/master/linkedin-icon.png?raw=true" width="60"></a>
<a href="https://facebook.com/imthepk"><img src="https://github.com/aritraroy/social-icons/blob/master/facebook-icon.png?raw=true" width="60"></a>
<a href="https://instagram.com/codepur_ka_superhero"><img src="https://github.com/aritraroy/social-icons/blob/master/instagram-icon.png?raw=true" width="60"></a>

# Donate

> If you found this project helpful or you learned something from the source code and want to thank me, consider buying me a cup of :coffee:
>
> - [PayPal](https://www.paypal.me/imthepk/)

### Note: VelocityX is not directly and/or indirectly associated/affiliated with Flutter or Google LLC.

## Active Contributors

1. Ayush Bherwani
1. Hasnen Tai
1. Harpreet Singh

## Copyright-and-license

Code and documentation Copyright 2020 [Pawan Kumar](https://pawan.live). Code released under the [Apache License](./LICENSE). Docs released under [Creative Commons](https://creativecommons.org/licenses/by/3.0/).
